<template>
  <div>
    <!--查询区域-->
    <div class="jeecg-basic-table-form-container">
      <a-form @keyup.enter.native="searchQuery" :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
        <a-row :gutter="24">
          <a-col :lg="8">
            <a-form-item label="主站点">
              <JSelectLinkSysSet v-model:value="queryParam.mainSiteId" ></JSelectLinkSysSet>
            </a-form-item>
          </a-col>
          <template v-if="toggleSearchStatus">
            <a-col :lg="8">
              <a-form-item label="外链地址">
                <a-input placeholder="请输入外链地址" v-model:value="queryParam.outerUrl"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="外链地址类型">
                <a-input placeholder="请输入外链地址类型" v-model:value="queryParam.outerUrlType"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="外链地址状态">
                <a-input placeholder="请输入外链地址状态" v-model:value="queryParam.outerUrlState"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="引用页面数">
                <a-input placeholder="请输入引用页面数" v-model:value="queryParam.numberApplicationPages"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="扫描次数">
                <a-input placeholder="请输入扫描次数" v-model:value="queryParam.numberScans"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="是否修改">
                <j-dict-select-tag placeholder="请选择是否修改" v-model:value="queryParam.isRevise" dictCode="verify_status"/>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="是否忽略">
                <j-dict-select-tag placeholder="请选择是否忽略" v-model:value="queryParam.isIgnore" dictCode="verify_status"/>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核时间">
                 <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择开始时间" v-model:value="queryParam.checkTime_begin" class="query-group-cust" />
                 <span class="query-group-split-cust">~</span>
                 <a-date-picker showTime value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择结束时间" v-model:value="queryParam.checkTime_end" class="query-group-cust" />
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核状态">
                <j-dict-select-tag placeholder="请选择复核状态" v-model:value="queryParam.checkState" dictCode="review_status"/>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核引用页面数">
                <a-input placeholder="请输入复核引用页面数" v-model:value="queryParam.checkNumberApplicationPagesv"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="8">
              <a-form-item label="复核信息">
                <a-input placeholder="请输入复核信息" v-model:value="queryParam.checkMessage"></a-input>
              </a-form-item>
            </a-col>
          </template>
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <span style="float: left; overflow: hidden" class="table-page-search-submitButtons">
              <a-col :lg="6">
                <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery">查询</a-button>
                <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset" style="margin-left: 8px">重置</a-button>
                <a @click="toggleSearchStatus = !toggleSearchStatus" style="margin-left: 8px">
                  {{ toggleSearchStatus ? '收起' : '展开' }}
                  <Icon :icon="toggleSearchStatus ? 'ant-design:up-outlined' : 'ant-design:down-outlined'" />
                </a>
              </a-col>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
        <a-button  type="primary" preIcon="ant-design:export-outlined" @click="exportXlslinkOuter"> 导出</a-button>
        <j-upload-button  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
        <a-button type="primary" @click="handleCrawling" preIcon="ant-design:redo-outlined">同步外链数据</a-button>
        <a-button type="primary" @click="onHandleCheckListLinkOuter" preIcon="ant-design:redo-outlined">复核外链数据</a-button>
        <a-dropdown v-if="selectedRowKeys.length > 0">
          <template #overlay>
            <a-menu>
              <a-menu-item key="1" @click="batchHandleDelete">
                <Icon icon="ant-design:delete-outlined"></Icon>
                删除
              </a-menu-item>
              <a-menu-item key="2" @click="batchIgnoreHandle">
                <Icon icon="ant-design:check-circle-outlined"></Icon>
                批量忽略
              </a-menu-item>
              <a-menu-item key="2" @click="batchIgnoreHandleDelete">
                <Icon icon="ant-design:check-circle-outlined"></Icon>
                批量取消忽略
              </a-menu-item>
              <a-menu-item key="4" @click="batchModifyTrue">
                <Icon icon="ant-design:check-circle-outlined"></Icon>
                批量已修改
              </a-menu-item>
              <a-menu-item key="5" @click="batchModifyFalse">
                <Icon icon="ant-design:close-circle-outlined"></Icon>
                批量取消已修改
              </a-menu-item>
              <a-menu-item key="2" @click="batchAddWhiteLink">
                <Icon icon="ant-design:check-circle-outlined"></Icon>
                批量设置链接不扫描
              </a-menu-item>
              <a-menu-item key="3" @click="batchRemoveWhiteLink">
                <Icon icon="ant-design:close-circle-outlined"></Icon>
                批量取消设置链接不扫描
              </a-menu-item>
            </a-menu>
          </template>
          <a-button>批量操作
            <Icon icon="mdi:chevron-down"></Icon>
          </a-button>
        </a-dropdown>
      </template>
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction  :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
        <div v-html="text"></div>
      </template>
      <template #aurl="{text}">
        <a :href="text" :title="text" target="_blank" >{{ subString(text)  }}</a>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
        {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
        <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
        <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <LinkOuterChainDetectionModal ref="registerModal" @success="handleSuccess"></LinkOuterChainDetectionModal>
    <a-drawer
      v-model:visible="visible"
      class="custom-class"
      style="color: red"
      :title="lickSet"
      placement="right"
      :width="1100"
      @after-visible-change="afterVisibleChange"
    >
      <ExternalInternalSiteListQuote v-if="visibleFlag" :lickSet="lickSet"></ExternalInternalSiteListQuote>
    </a-drawer>
    <a-modal
      v-model:visible="visiblemodify"
      :title="'是否已经修改：'+title"
      ok-text="已经修改"
      cancel-text="取消"
      @ok="hideModalSelectOk"
      @cancel="closeModalSelect"
    >
      <div style="text-align: center">
        <div style="padding: 50px;text-align: left">
          <a target="_blank" :href="outerUrl">{{ outerUrl }}</a><br>
          <a target="_blank" :href="outerUrl">{{ LinkChainErrorDetectionId }}</a>
        </div>
      </div>
      <template #footer>
        <a-button @click="closeModalSelect">关闭</a-button>
        <a-button type="primary" @click="hideModalSelectCancel">未修改</a-button>
        <a-button type="primary" @click="hideModalSelectOk">已经修改</a-button>
      </template>
    </a-modal>
    <a-modal
      v-model:visible="visibleIgnore"
      :title="'是否已经忽略：'+title"
      ok-text="已经忽略"
      cancel-text="取消"
      @ok="hideIgnoreSelectOk"
      @cancel="closeIgnoreModalSelect"
    >
      <div style="text-align: center">
        <div style="padding: 50px;text-align: left">
          <a target="_blank" :href="outerUrl">{{ outerUrl }}</a><br>
          <a target="_blank" :href="outerUrl">{{ LinkChainErrorDetectionId }}</a>
        </div>
      </div>
      <template #footer>
        <a-button @click="closeIgnoreModalSelect">关闭</a-button>
        <a-button type="primary" @click="closeIgnoreSelect">不忽略</a-button>
        <a-button type="primary" @click="hideIgnoreSelectOk">忽略</a-button>
      </template>
    </a-modal>
    <a-modal
      v-model:visible="visibleNotScan"
      :title="'是否设置不扫描：'+title"
      ok-text="设置不扫描"
      cancel-text="取消"
      @ok="hideNotScanSelectOk"
      @cancel="closeNotScanModalSelect"
    >
      <div style="text-align: center">
        <div style="padding: 50px;text-align: left">
          <a target="_blank" :href="outerUrl">{{ outerUrl }}</a><br>
          <a target="_blank" :href="outerUrl">{{ LinkChainErrorDetectionId }}</a>
        </div>
      </div>
      <template #footer>
        <a-button @click="closeNotScanModalSelect">关闭</a-button>
        <a-button type="primary" @click="hideScanSelectOk">设置扫描</a-button>
        <a-button type="primary" @click="hideNotScanSelectOk">设置不扫描</a-button>
      </template>
    </a-modal>
  </div>
</template>

<script lang="ts" name="linkouterchaindetection-linkOuterChainDetection" setup>
import {ref, reactive, onBeforeMount,watch} from 'vue';
  import { BasicTable } from '/@/components/Table';
  import { useTable } from '/@/components/Table';
  import { TableAction } from '/@/components/Table';
  import JDictSelectTag from '/@/components/Form/src/jeecg/components/JDictSelectTag.vue';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { columns } from './LinkOuterChainDetection.data';
  import { list, deleteOne, batchDelete,ignoreBatchDelete,ignoreAllCancellBatchDelete,ModifyTrueBatchDelete,ModifyFalseBatchDelete, getImportUrl, getExportUrl } from './LinkOuterChainDetection.api';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import LinkOuterChainDetectionModal from './components/LinkOuterChainDetectionModal.vue'
  import JSelectLinkSysSet from '/@/components/Form/src/jeecg/components/JSelectLinkSysSet.vue';
  import ExternalInternalSiteListQuote from '/@/views/demo/externalinternalsite/ExternalInternalSiteListQuote.vue';
  import {defHttp} from "/@/utils/http/axios";
  import {useRouter} from "vue-router";
  import {
    batchHAddWhiteLink,
    batchHIgnoreHandle,
    batchHIgnoreHandleDelete, batchHModifyFalse, batchHModifyTrue, batchHRemoveWhiteLink
  } from "/@/views/demo/linkouterchaindetection/LinkOuterChainDetection.api";
  const queryParam = ref<any>({});
  const toggleSearchStatus = ref<boolean>(false);
  const registerModal = ref();
  const router = useRouter();
  const visible = ref<boolean>(false);
  const errorUrl = ref();
  const outerUrl = ref();
  const lickSet = ref();
  const title = ref("");
  const visiblemodify = ref<boolean>(false);
  const visibleFlag = ref<boolean>(false);
  const visibleIgnore = ref<boolean>(false);
  const visibleNotScan = ref<boolean>(false);
  const LinkChainErrorDetectionId = ref();
  //注册table数据
  const { prefixCls, tableContext, exportXlslinkOuter, onImportXls,onHandleCheckListLinkOuter } = useListPage({
    tableProps: {
      title: '外链检测',
      api: list,
      columns,
      canResize:false,
      useSearchForm: false,
      actionColumn: {
        width: 120,
        fixed: 'right',
      },
      beforeFetch: (params) => {
        return Object.assign(params, queryParam.value);
      },
    },
    exportConfig: {
      name: "外链检测",
      url: getExportUrl,
    },
	  importConfig: {
	    url: getImportUrl,
	    success: handleSuccess
	  },
  });
  const [registerTable, { reload, collapseAll, updateTableDataRecord, findTableDataRecord, getDataSource }, { rowSelection, selectedRowKeys }] = tableContext;
  const labelCol = reactive({
    xs: { span: 24 },
    sm: { span: 7 },
  });
  const wrapperCol = reactive({
    xs: { span: 24 },
    sm: { span: 16 },
  });
  const afterVisibleChange = (bool: boolean) => {
    console.log('visible', bool);
  };
function subString(str:string){
  if(str.length > 15){
    str = str.substring(0,15) + "....."
  }
  return str
}
  const showDrawer = (record: Recordable) => {
    console.log(record)
    lickSet.value = record.outerUrl;
    visible.value = true;
    visibleFlag.value = false;
    setTimeout(function() {
      visibleFlag.value = true;
    }, 500); // 定时时间
  };
  onBeforeMount(()=>{
    queryParam.value.isIgnore = "1"
    var mainSite = localStorage.getItem("main_site");
    if(mainSite != null){
      try {
        var objMainSite = JSON.parse(mainSite);
        if(objMainSite.id != null && objMainSite.id != ""){
          queryParam.value.mainSiteId = objMainSite.id
        }
      }catch (err){
        queryParam.value.mainSiteId = null
      }
    }else {
      queryParam.value.mainSiteId = null
    }
    localStorage.removeItem("query_param");
    localStorage.setItem("query_param",JSON.stringify(queryParam));

  })

  const closeModalSelect = () => {
    visiblemodify.value = false;
  };
  const closeIgnoreModalSelect = () => {
    visibleIgnore.value = false;
  };
  const closeNotScanModalSelect = () => {
    visibleNotScan.value = false;
  };

  const hideNotScanSelectOk = () => {
    if(LinkChainErrorDetectionId.value != null){
      defHttp.get({
        url:'/linkouterchaindetection/linkOuterChainDetection/addWhiteLink?id='+LinkChainErrorDetectionId.value
      }).then((res)=>{
        reload();
      })
    }
    visibleNotScan.value = false;
  };

  const hideScanSelectOk = () => {
    if(LinkChainErrorDetectionId.value != null){
      defHttp.get({
        url:'/linkouterchaindetection/linkOuterChainDetection/removeWhiteLink?id='+LinkChainErrorDetectionId.value
      }).then((res)=>{
        reload();
      })
    }
    visibleNotScan.value = false;
  };


  const hideIgnoreSelectOk = () => {
    if(LinkChainErrorDetectionId.value != null){
      defHttp.get({
        url:'/linkouterchaindetection/linkOuterChainDetection/queryByIdIgnoreTrue?id='+LinkChainErrorDetectionId.value
      }).then((res)=>{
        reload();
      })
    }
    visibleIgnore.value = false;
  };

  const closeIgnoreSelect = () => {
    if(LinkChainErrorDetectionId.value != null){
      defHttp.get({
        url:'/linkouterchaindetection/linkOuterChainDetection/queryByIdIgnoreFalse?id='+LinkChainErrorDetectionId.value
      }).then((res)=>{
        reload();
      })
    }
    visibleIgnore.value = false;
  };

  const hideModalSelectOk = () => {
    if(LinkChainErrorDetectionId.value != null){
      defHttp.get({
        url:'/linkouterchaindetection/linkOuterChainDetection/queryByIdModifyTrue?id='+LinkChainErrorDetectionId.value
      }).then((res)=>{
        reload();
      })
    }
    visiblemodify.value = false;
  };

  const hideModalSelectCancel = () => {
    if(LinkChainErrorDetectionId.value != null){
      defHttp.get({
        url:'/linkouterchaindetection/linkOuterChainDetection/queryByIdModifyFalse?id='+LinkChainErrorDetectionId.value
      }).then((res)=>{
        reload();
      })
    }
    visiblemodify.value = false;
  };

  function checkCrawling() {
    defHttp.get({
      url:'/linkouterchaindetection/linkOuterChainDetection/checkListErrorLink',
      timeout:1000000,
    }).then((res)=>{
      reload()
    })
  }

  function spyderCrawling() {
    defHttp.get({
      url:'/linkouterchaindetection/linkOuterChainDetection/spyderListErrorLink',
      timeout:1000000,
    }).then((res)=>{
      reload()
    })
  }
  /**
   * 新增事件
   */
  function handleDrawer(record: Recordable) {
    showDrawer(record);
  }
  /**
   * 新增事件
   */
  function handleAdd() {
    registerModal.value.disableSubmit = false;
    registerModal.value.add();
  }

  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    registerModal.value.disableSubmit = false;
    registerModal.value.edit(record);
  }

  /**
   * 详情
   */
  function handleDetail(record: Recordable) {
    registerModal.value.disableSubmit = true;
    registerModal.value.edit(record);
  }

  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, handleSuccess);
  }
  const showModalVisiblemodify = (record: Recordable) => {
    outerUrl.value = record.outerUrl;
    LinkChainErrorDetectionId.value = record.id
    visiblemodify.value = true;
  };
  const showIgnoreVisiblemodify = (record: Recordable) => {
    outerUrl.value = record.outerUrl;
    LinkChainErrorDetectionId.value = record.id
    visibleIgnore.value = true;
  };
  const showNotScanVisiblemodify = (record: Recordable) => {
    outerUrl.value = record.outerUrl;
    LinkChainErrorDetectionId.value = record.id
    visibleNotScan.value = true;
  };
  /**
   * 批量删除事件
   */
    /**
     * 批量删除事件
     */
    async function batchHandleDelete() {
      await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
    }

    async function batchIgnoreHandle() {
      await batchHIgnoreHandle({ ids: selectedRowKeys.value }, handleSuccess);
    }
    async function batchIgnoreHandleDelete() {
      await batchHIgnoreHandleDelete({ ids: selectedRowKeys.value }, handleSuccess);
    }
    async function batchModifyTrue() {
      await batchHModifyTrue({ ids: selectedRowKeys.value }, handleSuccess);
    }
    async function batchModifyFalse() {
      await batchHModifyFalse({ ids: selectedRowKeys.value }, handleSuccess);
    }
    async function batchAddWhiteLink() {
      await batchHAddWhiteLink({ ids: selectedRowKeys.value }, handleSuccess);
    }
    async function batchRemoveWhiteLink() {
      await batchHRemoveWhiteLink({ ids: selectedRowKeys.value }, handleSuccess);
    }
  /**
   * 成功回调
   */
  function handleSuccess() {
    (selectedRowKeys.value = []) && reload();
  }

  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      {
        label: '编辑',
        onClick: handleEdit.bind(null, record),
      },
    ];
  }
  /**
   * 实时定位
   */
  function realTimeEdit(record: Recordable) {
    const url = router.resolve({
      path: '/MyIndexLink/'+record.id
    });
    window.open(url.href);
  }
  /**
   * 实时定位
   */
  function oldTimeEdit(record: Recordable) {
    const url = router.resolve({
      path: '/MyIndexOldLink/'+record.id
    });
    window.open(url.href);
  }

    /**
     * 详情
     */
    function handleModify(record: Recordable) {
      showModalVisiblemodify(record);
    }
    /**
     * 详情
     */
    function handleIgnore(record: Recordable) {
      showIgnoreVisiblemodify(record);
    }
    function handleNotScan(record: Recordable) {
      showNotScanVisiblemodify(record);
    }
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [
      {
        label: '引用页面',
        onClick: handleDrawer.bind(null, record),
      },
      {
        label: '设置是否已经修改',
        onClick: handleModify.bind(null, record),
      },
      {
        label: '是否忽略',
        onClick: handleIgnore.bind(null, record),
      },
      {
        label: '设置链接不扫描',
        onClick: handleNotScan.bind(null, record),
      },
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      },
      {
        label: '删除',
        popConfirm: {
          title: '是否确认删除',
          confirm: handleDelete.bind(null, record),
        }
      }
    ]
  }
  /**
   * 新增事件
   */
  function handleCheck() {
    defHttp.get({
      url:'/linkouterchaindetection/linkOuterChainDetection/checkListOuter',
      timeout:100000,
    }).then((res)=>{
      reload()
    })
  }
  /**
   * 新增事件
   */

  function handleCrawling() {
    defHttp.get({
      url:'/linkouterchaindetection/linkOuterChainDetection/updateListOuter',
      timeout:100000,
    }).then((res)=>{
      reload()
    })
  }
  /**
   * 查询
   */
  function searchQuery() {
    reload();
  }

  /**
   * 重置
   */
  function searchReset() {
    queryParam.value = {};
    selectedRowKeys.value = [];
    //刷新数据
    reload();
  }

  watch(queryParam.value, (newValue, oldValue) => {
    localStorage.removeItem("query_param");
    localStorage.setItem("query_param",JSON.stringify(newValue));
  })


</script>

<style lang="less" scoped>
  .jeecg-basic-table-form-container {
    .table-page-search-submitButtons {
      display: block;
      margin-bottom: 24px;
      white-space: nowrap;
    }
    .query-group-cust{
      width: calc(50% - 15px);
      min-width: 100px !important;
    }
    .query-group-split-cust{
      width: 30px;
      display: inline-block;
      text-align: center
    }
  }
</style>
